      subroutine sphbes(lval,ndim,x)
      implicit real*8(a-h,o-z)
!   returns jl(x)  ,spherical bessel function of order lval
!    and also
!  on input x(i) is argument array
!  on output x(i) is jl(x)
      real*8 x(ndim)
! ---- find bessel function derivative
      do 100 it=1,ndim
      z=x(it)
      if(z.gt.0.5d0) go to 20
! --- special treatment if z = 0
      if (z.gt.1.d-7) go to 13
      bs=0.d0
      if(lval.eq.0) bs=1.d0
      go to 30
   13 continue
!  series expansion
      lll=2*lval+1
      xx=1.d0
      do 15 l=1,lll,2
   15 xx=xx*l
      z2=0.5d0*z*z
      lll=lll+2
      arg=-z2/lll
      sum=1.d0+arg
      do 18 n=2,500
      lll=lll+2
      arg=-arg*z2/(n*lll)
      sum=sum+arg
      if (abs(arg).le.1.d-9) go to 19
   18 continue
   19 continue
      bs=(z**lval)*sum/xx
      go to 30
   20 continue
! -- trigometric form
      bs=sin(z)/z
      if (lval.eq.0) go to 30
      bs0=bs
      bs=(bs0-cos(z))/z
      if (lval.eq.1) go to 30
      bs1=bs
      do 25 il=2,lval
      bs=(2*il-1)*bs1/z-bs0
      bs0=bs1
      bs1=bs
   25 continue
   30 continue
   99 x(it)=bs
  100 continue
      return
       end
